VTK: vtkAMRInterpolatedVelocityField Class Reference

| VTK 9.0.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkAMRInterpolatedVelocityField Class Reference

A concrete class for obtaining the interpolated velocity values at a point in AMR data. More...

`#include <vtkAMRInterpolatedVelocityField.h>`

Inheritance diagram for vtkAMRInterpolatedVelocityField:
[legend]
Collaboration diagram for vtkAMRInterpolatedVelocityField:
[legend]

## Public Types
typedef vtkAbstractInterpolatedVelocityField | Superclass
Public Types inherited from vtkAbstractInterpolatedVelocityField
typedef vtkFunctionSet | Superclass
Public Types inherited from vtkFunctionSet
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkAMRInterpolatedVelocityField * | NewInstance () const
virtual vtkOverlappingAMR * | GetAmrDataSet ()
void | SetAMRData (vtkOverlappingAMR *amr)
bool | GetLastDataSetLocation (unsigned int &level, unsigned int &id)
bool | SetLastDataSet (int level, int id)
void | SetLastCellId (vtkIdType c, int dataindex) override
| Set the id of the most recently visited cell of a dataset. More...
void | SetLastCellId (vtkIdType c) override
| Set the cell id cached by the last evaluation. More...
int | FunctionValues (double *x, double *f) override
| Evaluate the velocity field f at point p. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
Public Member Functions inherited from vtkAbstractInterpolatedVelocityField
vtkAbstractInterpolatedVelocityField * | NewInstance () const
virtual void | SetCaching (bool)
| Set/Get the caching flag. More...
virtual bool | GetCaching ()
virtual int | GetCacheHit ()
| Get the caching statistics. More...
virtual int | GetCacheMiss ()
virtual vtkDataSet * | GetLastDataSet ()
virtual vtkIdType | GetLastCellId ()
| Get/Set the id of the cell cached from last evaluation. More...
virtual char * | GetVectorsSelection ()
| Get/Set the name of a spcified vector array. More...
virtual int | GetVectorsType ()
void | SelectVectors (int fieldAssociation, const char *fieldName)
| the association type (see vtkDataObject::FieldAssociations) and the name of the velocity data field More...
virtual void | SetNormalizeVector (bool)
| Set/Get the flag indicating vector post-normalization (following vector interpolation). More...
virtual bool | GetNormalizeVector ()
virtual void | SetForceSurfaceTangentVector (bool)
| If set to true, the first three point of the cell will be used to compute a normal to the cell, this normal will then be removed from the vorticity so the resulting vector in tangent to the cell. More...
virtual bool | GetForceSurfaceTangentVector ()
virtual void | SetSurfaceDataset (bool)
| If set to true, cell within tolerance factor will always be found, except for edges. More...
virtual bool | GetSurfaceDataset ()
virtual void | CopyParameters (vtkAbstractInterpolatedVelocityField *from)
| Import parameters. More...
void | ClearLastCellId ()
| Set the last cell id to -1 to incur a global cell search for the next point. More...
int | GetLastWeights (double *w)
| Get the interpolation weights cached from last evaluation. More...
int | GetLastLocalCoordinates (double pcoords[3])
virtual void | SetFindCellStrategy (vtkFindCellStrategy *)
| Set / get the strategy used to perform the FindCell() operation. More...
virtual vtkFindCellStrategy * | GetFindCellStrategy ()
Public Member Functions inherited from vtkFunctionSet
vtkFunctionSet * | NewInstance () const
virtual int | FunctionValues (double *x, double *f, void *vtkNotUsed(userData))
virtual int | GetNumberOfFunctions ()
| Return the number of functions. More...
virtual int | GetNumberOfIndependentVariables ()
| Return the number of independent variables. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
vtkCommand * | GetCommand (unsigned long tag)
void | RemoveObserver (vtkCommand *)
void | RemoveObservers (unsigned long event, vtkCommand *)
void | RemoveObservers (const char *event, vtkCommand *)
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
int | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
int | InvokeEvent (const char *event, void *callData)
int | InvokeEvent (unsigned long event)
int | InvokeEvent (const char *event)
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
void | PrintRevisions (ostream &)
| Legacy. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAMRInterpolatedVelocityField * | SafeDownCast (vtkObjectBase *o)
static vtkAMRInterpolatedVelocityField * | New ()
static bool | FindGrid (double q[3], vtkOverlappingAMR *amrds, unsigned int &level, unsigned int &gridId)
Static Public Member Functions inherited from vtkAbstractInterpolatedVelocityField
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAbstractInterpolatedVelocityField * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkFunctionSet
static vtkTypeBool | IsTypeOf (const char *type)
static vtkFunctionSet * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (int val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
static void | GlobalWarningDisplayOff ()
static int | GetGlobalWarningDisplay ()
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkAMRInterpolatedVelocityField ()
| ~vtkAMRInterpolatedVelocityField () override
int | FunctionValues (vtkDataSet *ds, double *x, double *f) override
| Evaluate the velocity field f at point (x, y, z) in a specified dataset by invoking vtkDataSet::FindCell() to locate the next cell if the given point is outside the current cell. More...
Protected Member Functions inherited from vtkAbstractInterpolatedVelocityField
| vtkAbstractInterpolatedVelocityField ()
| ~vtkAbstractInterpolatedVelocityField () override
virtual void | SetVectorsSelection (const char *)
| Set the name of a specific vector to be interpolated. More...
virtual bool | CheckPCoords (double pcoords[3])
| Check that all three pcoords are between 0 and 1 included. More...
virtual bool | FindAndUpdateCell (vtkDataSet *ds, double *x)
| Try to find the cell closest to provided x point in provided dataset, By first testing inclusion in it's cached cell and neighbor Then testing globally Then , only if surfacic is activated finding the closest cell using FindPoint and comparing distance with tolerance. More...
void | FastCompute (vtkDataArray *vectors, double f[3])
| If all weights have been computed (parametric coords etc all valid), a scalar/vector can be quickly interpolated using the known weights and the cached generic cell. More...
bool | InterpolatePoint (vtkPointData *outPD, vtkIdType outIndex)
vtkGenericCell * | GetLastCell ()
Protected Member Functions inherited from vtkFunctionSet
| vtkFunctionSet ()
| ~vtkFunctionSet () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | CollectRevisions (ostream &)
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkOverlappingAMR * | AmrDataSet
int | LastLevel
int | LastId
Protected Attributes inherited from vtkAbstractInterpolatedVelocityField
int | CacheHit
int | CacheMiss
int | WeightsSize
bool | Caching
bool | NormalizeVector
bool | ForceSurfaceTangentVector
bool | SurfaceDataset
int | VectorsType
char * | VectorsSelection
double * | Weights
double | LastPCoords [3]
int | LastSubId
vtkIdType | LastCellId
vtkDataSet * | LastDataSet
vtkGenericCell * | Cell
vtkGenericCell * | GenCell
vtkFindCellStrategy * | FindCellStrategy
vtkStrategyMap * | StrategyMap
Protected Attributes inherited from vtkFunctionSet
int | NumFuncs
int | NumIndepVars
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Attributes inherited from vtkAbstractInterpolatedVelocityField
static const double | TOLERANCE_SCALE
static const double | SURFACE_TOLERANCE_SCALE

## Detailed Description

A concrete class for obtaining the interpolated velocity values at a point in AMR data.

The main functionality supported here is the point location inside vtkOverlappingAMR data set.

Definition at line 34 of file vtkAMRInterpolatedVelocityField.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkAbstractInterpolatedVelocityField vtkAMRInterpolatedVelocityField::Superclass

Definition at line 38 of file vtkAMRInterpolatedVelocityField.h.

## Constructor & Destructor Documentation

## ◆ vtkAMRInterpolatedVelocityField()

vtkAMRInterpolatedVelocityField::vtkAMRInterpolatedVelocityField | ( |  | ) |
| protected

## ◆ ~vtkAMRInterpolatedVelocityField()

vtkAMRInterpolatedVelocityField::~vtkAMRInterpolatedVelocityField | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkAMRInterpolatedVelocityField::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkAMRInterpolatedVelocityField::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkAbstractInterpolatedVelocityField.

## ◆ SafeDownCast()

static vtkAMRInterpolatedVelocityField* vtkAMRInterpolatedVelocityField::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkAMRInterpolatedVelocityField::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkAbstractInterpolatedVelocityField.

## ◆ NewInstance()

vtkAMRInterpolatedVelocityField* vtkAMRInterpolatedVelocityField::NewInstance | ( |  | ) | const

## ◆ New()

static vtkAMRInterpolatedVelocityField* vtkAMRInterpolatedVelocityField::New | ( |  | ) |
| static

## ◆ GetAmrDataSet()

virtual vtkOverlappingAMR* vtkAMRInterpolatedVelocityField::GetAmrDataSet | ( |  | ) |
| virtual

## ◆ SetAMRData()

void vtkAMRInterpolatedVelocityField::SetAMRData | ( | vtkOverlappingAMR * | amr | ) |

## ◆ GetLastDataSetLocation()

bool vtkAMRInterpolatedVelocityField::GetLastDataSetLocation | ( | unsigned int & | level,
|  | unsigned int & | id
| ) |  |

## ◆ SetLastDataSet()

bool vtkAMRInterpolatedVelocityField::SetLastDataSet | ( | int | level,
|  | int | id
| ) |  |

## ◆ SetLastCellId() [1/2]

void vtkAMRInterpolatedVelocityField::SetLastCellId | ( | vtkIdType | c,
|  | int | dataindex
| ) |  |
| overridevirtual

Set the id of the most recently visited cell of a dataset.

Implements vtkAbstractInterpolatedVelocityField.

## ◆ SetLastCellId() [2/2]

void vtkAMRInterpolatedVelocityField::SetLastCellId | ( | vtkIdType | c | ) |
| inlineoverridevirtual

Set the cell id cached by the last evaluation.

Reimplemented from vtkAbstractInterpolatedVelocityField.

Definition at line 54 of file vtkAMRInterpolatedVelocityField.h.

## ◆ FunctionValues() [1/2]

int vtkAMRInterpolatedVelocityField::FunctionValues | ( | double * | x,
|  | double * | f
| ) |  |
| overridevirtual

Evaluate the velocity field f at point p.

If it succeeds, then both the last data set (this->LastDataSet) and the last data set location (this->LastLevel, this->LastId) will be set according to where p is found. If it fails, either p is out of bound, in which case both the last data set and the last location will be invalid or, in a multi-process setting, p is inbound but not on the processor. In the last case, the last data set location is still valid

Implements vtkAbstractInterpolatedVelocityField.

## ◆ PrintSelf()

void vtkAMRInterpolatedVelocityField::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkAbstractInterpolatedVelocityField.

## ◆ FindGrid()

static bool vtkAMRInterpolatedVelocityField::FindGrid | ( | double | q[3],
|  | vtkOverlappingAMR * | amrds,
|  | unsigned int & | level,
|  | unsigned int & | gridId
| ) |  |
| static

## ◆ FunctionValues() [2/2]

int vtkAMRInterpolatedVelocityField::FunctionValues | ( | vtkDataSet * | ds,
|  | double * | x,
|  | double * | f
| ) |  |
| inlineoverrideprotectedvirtual

Evaluate the velocity field f at point (x, y, z) in a specified dataset by invoking vtkDataSet::FindCell() to locate the next cell if the given point is outside the current cell.

To address vtkPointSet, vtkPointLocator is involved via vtkPointSet::FindCell() in vtkInterpolatedVelocityField for cell location. In vtkCellLocatorInterpolatedVelocityField, this function is invoked just to handle vtkImageData and vtkRectilinearGrid that are not assigned with any vtkAbstractCellLocatot-type cell locator. If activated, returned vector will be tangential to the first three point of the cell

Reimplemented from vtkAbstractInterpolatedVelocityField.

Definition at line 84 of file vtkAMRInterpolatedVelocityField.h.

## Member Data Documentation

## ◆ AmrDataSet

vtkOverlappingAMR* vtkAMRInterpolatedVelocityField::AmrDataSet
| protected

Definition at line 78 of file vtkAMRInterpolatedVelocityField.h.

## ◆ LastLevel

int vtkAMRInterpolatedVelocityField::LastLevel
| protected

Definition at line 79 of file vtkAMRInterpolatedVelocityField.h.

## ◆ LastId

int vtkAMRInterpolatedVelocityField::LastId
| protected

Definition at line 80 of file vtkAMRInterpolatedVelocityField.h.

The documentation for this class was generated from the following file:

- Filters/FlowPaths/vtkAMRInterpolatedVelocityField.h